export function number(value) {
    return { type: "number", value };
}
export function boolean(value) {
    return { type: "boolean", value };
}
export function string(value) {
    return { type: "string", value };
}
export function ref(key, path) {
    return {
        type: "ref",
        value: string(`$${[key].concat(path).join(".")}`),
        key,
        path,
    };
}
export function list(value) {
    return { type: "list", value };
}
export function map(value) {
    return {
        type: "map",
        value: new Map(Object.entries(value).map(([k, v]) => {
            return [string(k), v];
        })),
    };
}
export function external(value, view) {
    return { type: "external", value, view };
}
export function fn(call, param) {
    return {
        type: "fn",
        param,
        value: {
            type: "native",
            call,
        },
    };
}
//# sourceMappingURL=data.js.map