"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.print = void 0;
const deps_js_1 = require("./deps.js");
const data = __importStar(require("./data.js"));
const read_js_1 = require("./read.js");
function print(value) {
    let doc = new deps_js_1.yaml.Document(toYAML(value));
    return data.string(doc.toString().slice(0, -1));
}
exports.print = print;
function toYAML(value) {
    if ((0, read_js_1.isLiteral)(value)) {
        return value.node;
    }
    switch (value.type) {
        case "string":
        case "number":
        case "boolean":
            return new deps_js_1.yaml.Scalar(value.value);
        case "list": {
            let seq = new deps_js_1.yaml.YAMLSeq();
            for (let item of value.value) {
                seq.add(toYAML(item));
            }
            return seq;
        }
        case "map": {
            let map = new deps_js_1.yaml.YAMLMap();
            for (let [k, v] of value.value.entries()) {
                map.add(new deps_js_1.yaml.Pair(toYAML(k), toYAML(v)));
            }
            return map;
        }
        case "ref":
        case "template":
            return toYAML(value.value);
        case "fn": {
            let map = new deps_js_1.yaml.YAMLMap();
            if (value.value.type === "platformscript") {
                map.add(new deps_js_1.yaml.Pair(toYAML(value.value.head), toYAML(value.value.body)));
            }
            else {
                let head = `(${value.param.name})=>`;
                let body = "<[native fn]>";
                map.add(new deps_js_1.yaml.Pair(new deps_js_1.yaml.Scalar(head), new deps_js_1.yaml.Scalar(body)));
            }
            return map;
        }
        case "fncall":
            return toYAML(value.source);
        case "external":
            return new deps_js_1.yaml.Scalar("<[external]>");
        default:
            throw new Error(`FATAL: non exhaustive print() match.`);
    }
}
//# sourceMappingURL=print.js.map